import { generateSQLCreateTable } from '../stringSQL/generateCREATE';
import { generateSQLInsertInto } from '../stringSQL/generateINSERT';
import { openDbSqlite } from '../SqliteStore/openDbSqlite';


export function setAuthDataInSqlite(payload: object, tableName = (process.env.REACT_APP_SQLITE_TABLE_AUTH as string) || 'Auth', isCreateDate?: boolean ) {

  let db = openDbSqlite();
  
  let { newSQLCreate } = generateSQLCreateTable(payload, tableName, isCreateDate)
  let { newSQLInsert, arrValuesPayload } = generateSQLInsertInto(payload, tableName);

  db.transaction(
    (tx) => {
      tx.executeSql(`DROP TABLE IF EXISTS ${tableName}`);
      tx.executeSql(newSQLCreate);
      tx.executeSql(newSQLInsert, arrValuesPayload);
    },
    (err) => {
      console.log(`Ошибка транзакции в setAuthDataInSqlite: `, err.message)
    },
    () => {  console.dir('Успешная транзакция setAuthDataInSqlite');  }
  );
}
